'use strict';

/**
 * 将带有rem的字符串转换为number
 * @method function
 * @param  {[string]} item [100rem]
 * @return {[number]}      [100]
 */

exports.deleteRem = function (item) {
    if (typeof item == 'number') {
        return item;
    } else if (typeof item == 'string') {
        return item.split('rem')[0];
    } else {
        throw '不支持的类型';
    }
};